//---------------------------------------------------------------------------
//
// TBufferPaint -
// Component source
//
// (C) 2000 Thomas Wolf / Remotion
//
// Contact me at:
// remotion@chello.at
//
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "BufferPaint.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
static inline void ValidCtrCheck(TBufferPaint *)
{
    new TBufferPaint(NULL);
}
//---------------------------------------------------------------------------
__fastcall TBufferPaint::TBufferPaint(TComponent* Owner)
    : TCustomControl(Owner)
{
    Buffer                  = new Graphics::TBitmap();

    WindowProcOld           = WindowProc;
    WindowProc              = WindowProcNew;

    ControlStyle            = ControlStyle << csAcceptsControls;
    ControlStyle            = ControlStyle << csCaptureMouse;
    ControlStyle            = ControlStyle << csClickEvents;
    ControlStyle            = ControlStyle << csDoubleClicks;

    Width                   = 100;
    Height                  = 100;
    Buffer->Width           = Width;
    Buffer->Height          = Height;
    FColor                  = clBlack;
}
__fastcall TBufferPaint::~TBufferPaint()
{
    delete Buffer;
}
//---------------------------------------------------------------------------

void __fastcall TBufferPaint::WindowProcNew(TMessage &Msg)
{
    switch (Msg.Msg)
    {
        case WM_ERASEBKGND:
            Msg.Result = false;
            break;
        default:
            WindowProcOld(Msg);
    }
}

void __fastcall TBufferPaint::WMSize(TWMSize &Message)
{
    Buffer->Width  = Width;
    Buffer->Height = Height;
    Invalidate();
}

void __fastcall TBufferPaint::Paint()
{
    /* Call 'OnClear' and clear buffer (if wanted) */
    bool Stop = false;
    if (FOnClear != NULL)
        FOnClear(this, &Stop);
    if (FAutoClear && (Stop == false)) {
        Buffer->Canvas->Brush->Color = FColor;
        Buffer->Canvas->FillRect(Rect(0,0,
            Buffer->Width,Buffer->Height));
    }
    /* Call 'OnPaint' and draw buffer (if wanted) */
    Stop = false;
    if (FOnPaint != NULL)
        FOnPaint(this, &Stop);
    if (Stop == false)
        Canvas->Draw(0,0,Buffer);
}

void __fastcall TBufferPaint::CMMouseEnter(TMessage &Msg)
{
    if (FOnMouseEnter != NULL)
    {
        /* Get screen mouse position */
        TPoint mpos;
        GetCursorPos(&mpos);

        /* Convert to client mouse position */
        mpos = ScreenToClient(mpos);

        /* Call event handler */
        FOnMouseEnter(this,TShiftState(),mpos.x,mpos.y);

        /* Redraw control */
        Invalidate();
    }
    TCustomControl::Dispatch(&Msg);
}

void __fastcall TBufferPaint::CMMouseLeave(TMessage &Message)
{
    if (FOnMouseLeave != NULL)
    {
        /* Get screen mouse position */
        TPoint mpos;
        GetCursorPos(&mpos);

        /* Convert to client mouse position */
        mpos = ScreenToClient(mpos);

        /* Call event handler */
        FOnMouseLeave(this,TShiftState(),mpos.x,mpos.y);

        /* Redraw control */
        Invalidate();
    }
    TCustomControl::Dispatch(&Message);
}

//---------------------------------------------------------------------------

void __fastcall TBufferPaint::SetColor(TColor Value)
{
    FColor = Value;
    Invalidate();
}

void __fastcall TBufferPaint::SetAutoClear(bool Value)
{
    FAutoClear = Value;
    Invalidate();
}

//---------------------------------------------------------------------------
namespace Bufferpaint
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[1] = {__classid(TBufferPaint)};
         RegisterComponents("Remotion", classes, 0);
    }
}
//---------------------------------------------------------------------------
